<?php
echo "\n\n";
echo "This code demonstrates the new callable typehint in PHP 5.4\n";
echo "It was written by Cal Evans <cal@calevans.com> as part of his\n";
echo "presentation at CodeWorks 2011. \n";
echo "\n";
echo "It is so simple and useless that it would be laughable to attempt\n";
echo "to assign it a license. Therefore all code herein is released into the \n";
echo "public domain by the author.\n\n";

/*
 * Setup error handling. Since the exception that will be thrown is catchable,
 * let's setup, catch it and keep the program going.
 */
function exception_error_handler($errno, $errstr, $errfile, $errline ) {
    throw new ErrorException($errstr, $errno, 0, $errfile, $errline);
}
set_error_handler("exception_error_handler");

/*
 * Define a string to use and the function that we will pass around.
 */
$name = 'Cal';
$myFunc = function($x) { echo " -".$x ."\n";};

/*
 * When a typehint fails, it throws an ErrorException. Let'swrap our little code
 * in a try/catch so we can handle it properly.
 */
try {
    echo "First, le'ts just prove the function works. This will echo {$name}\n";
    echo "out to the screen.\n\n";  
    $myFunc($name);
    
    echo "\n\nok, now let's hand the function off as a parameter to another function that \n";
    echo "expects a callable as it's only paramebter.\n\n";
    doMyFunc($myFunc);
    
    echo "\n\nFinally, let's show that it does not work. This will throw an exception that \n";
    echo "will be processed in the catch below.\n\n";
    doMyFunc($name);
    
} catch (Exception $e) {
    echo "EXCEPTION!\n";
    echo "Hmmm Something went wrong. Here's the error message.\n";
    echo $e->getMEssage()."\n";
}

echo "\nThere, we are done. \n";
die();

/*
 * Here's the point of all these echo statements with code interspersed, see
 * the "Callable"? That's the typehint. Without that, the second call to
 * doMyFunc() would actually work but the call to $thisFunc() would fail because
 * a string is not callable.
 */
function doMyFunc(Callable $thisFunc) {
    for($lcvA=0;$lcvA<10;$lcvA++) {
        $thisFunc($lcvA);
    }
    echo "\n\n";
    return;
}
