<?php
echo "\n\n";
echo "This code demonstrates the JsonSerializable interface that is new in PHP 5.4\n";
echo "It was written by Cal Evans <cal@calevans.com> as part of his\n";
echo "presentation at CodeWorks 2011. \n";
echo "\n";
echo "It is so simple and useless that it would be laughable to attempt\n";
echo "to assign it a license. Therefore all code herein is released into the \n";
echo "public domain by the author.\n\n";

/*
 * Old way
 */
class MyClass
{

        public    $one   = "Cal";
        protected $two   = "Was";
        private   $three = "here";
}
echo "Here is the old way\n\n";
$object = new MyClass();
echo "\nHere is the class:\n";
print_r($object);
$jsonEncodedObject = json_encode($object);
echo "\n\n";
echo "\nHere is the json encoded version of the class:\n";
print_r($jsonEncodedObject);
echo "\n\n";

$object            = null;
$jsonEncodedObject = null;


/*
 * New Way
 */

class MySerilazableClass implements JsonSerializable
{

        public    $one   = "Cal";
        protected $two   = "Was";
        private   $three = "here";
    
    public function jsonSerialize()
    {
        /*
         * Do anything you want here. Calculate a value, check your klout score,
         * count the letters in each property.
         */
        return [
            'one'=>$this->one,
            'two'=>$this->two,
            'three'=>$this->three,
            'doesntExist'=>'You can really screw with things if you want.'
        ];
    }
}

$object = new MySerilazableClass();
echo "\nHere is the class:\n";
print_r($object);
$jsonEncodedObject = json_encode($object);
echo "\n\n";
echo "\nHere is the json encoded version of the class:\n";
print_r($jsonEncodedObject);
echo "\n\n";

echo "\nThere, we are done. \n";
die();











